
/**
 * Main callback for SimpleTest Automator functions.
 */
Drupal.behaviors.simpleTestAutomator = function() {
  for (i in Drupal.behaviors.simpleTestAutomator) {
     Drupal.behaviors.simpleTestAutomator[i]();
  }
}

/**
 * Convert clicking on links to $this->clickLink().
 */
Drupal.behaviors.simpleTestAutomator.trapSimpleTestClick = function() {
  $('a[href]:not(.trappedSimpleTestClick)').each(function() {
    $(this).addClass('trappedSimpleTestClick').click(function() {
      var content = $(this).text();
      var elems = $('a[href]').filter(function() {
        return $(this).text() == content;
      });

      for (var i = 0; i < elems.length; i++) {
        if (elems[i] == this) {
          break;
        }
      }

      $('body').css('cursor', 'wait');
      Drupal.simpleTestAutomator.record('// Click the %s link.', {'content': content});
      if (i) {
        Drupal.simpleTestAutomator.record('$this->clickLink(t(%s), %d)', {'content': content, 'index': i});
      }
      else {
        Drupal.simpleTestAutomator.record('$this->clickLink(t(%s))', {'content': content});
      }
    });
  });
};

/**
 * When we've selected text, give the option to check for that text.
 */
Drupal.behaviors.simpleTestAutomator.recordSimpleTestText = function() {
  $('body').mouseup(function() {
    var selected = window.getSelection ? window.getSelection() : (document.getSelection ? document.getSelection() : (document.selection ? document.selection.createRange().text : ''));
    selected = selected.toString();
    if (selected && confirm('Would you like to make sure that this text (' + selected + ') shows up?')) {
      Drupal.simpleTestAutomator.record('$this->assertText(t(%s), t(%s, array(\'%%message\' => %s)))', {'_text': selected, 'message': 'Make sure the %message message shows up.', '_message': selected});
    }
  });
}

/**
 * Record some SimpleTest code to PHP.
 */
Drupal.simpleTestAutomator.record = function (text, args) {
  args.text = text;
  $.ajax({
    'async': false,
    'cache': false,
    'url': Drupal.settings.basePath + 'simpletest_automator/js',
    'data': args,
    'timeout': 30,
    'error': function() { alert('An error has occurred.'); },
    'type': 'POST'
  });
}